/*
 *
 *
 *
 */
#ifndef _MSGB_FIFO_H_
#define _MSGB_FIFO_H_

#include "dlist.h"

struct msgb_fifo {
	int size;
	int nr_entries;
	struct dlist_head entries;
};

/**
 *
 */
int msgb_fifo_init(struct msgb_fifo *fifo, const int size);

/**
 *
 */
struct msgb_fifo *msgb_fifo_alloc(const int size);

/**
 *
 */
int msgb_fifo_destroy(struct msgb_fifo *fifo);

/**
 *
 */
int msgb_fifo_size(const struct msgb_fifo *fifo);

/**
 *
 */
int msgb_fifo_empty(const struct msgb_fifo *fifo);

/**
 *
 */
int msgb_fifo_full(const struct msgb_fifo *fifo);

/**
 *
 */
int msgb_fifo_length(const struct msgb_fifo *fifo);

/**
 *
 */
int msgb_fifo_enqueue(struct msgb_fifo *fifo, struct msgb *msg);

/**
 *
 */
struct msgb *msgb_fifo_dequeue(struct msgb_fifo *fifo);

#endif /* _MSGB_FIFO_H_ */
