/*
 * ISO 3166-1 Numeric-, Two-Letter Codes and Names
 * Taken from: http://en.wikipedia.org/wiki/ISO_3166-1
 */
#ifndef _ISO3166_H_
#define _ISO3166_H_

int iso3166_by_id(unsigned short id, const char **code, const char **name);
int iso3166_by_code(const char *code, unsigned short *id, const char **name);

#endif
