/*
 *
 *
 *
 */
#ifndef _STRSTREAM_H_
#define _STRSTREAM_H_

struct strstream {
	int  size;
	int  offset;

	char *buf;
};

#define STRSTREAM_SIZE	6192

int strstream_init(struct strstream *s, const int size);
int strstream_init_static(struct strstream *s, char *buf, const int size);

int strstream_printf(struct strstream *s, const char *fmt, ...);
int strstream_puts(struct strstream *s, const char *str);
int strstream_printhex(struct strstream *s, const char *buf, const int size);

int strstream_length(struct strstream *s);
int strstream_size(struct strstream *s);
int strstream_left(struct strstream *s);

const char *strstream_get(struct strstream *s);

#endif
